Osi 0.107.7

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Classes | Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
dupcol_action Class Reference

Detect and remove duplicate columns. More...

`#include <CoinPresolveDupcol.hpp>`

Inheritance diagram for dupcol_action:
[legend]
Collaboration diagram for dupcol_action:
[legend]

## Classes
struct | action

## Public Member Functions
const char * | name () const
| A name for debug printing. More...
void | postsolve (CoinPostsolveMatrix *prob) const
| Apply the postsolve transformation for this particular presolve action. More...
virtual | ~dupcol_action ()
Public Member Functions inherited from CoinPresolveAction
| CoinPresolveAction (const CoinPresolveAction *next)
| Construct a postsolve object and add it to the transformation list. More...
void | setNext (const CoinPresolveAction *nextAction)
| modify next (when building rather than passing) More...
virtual | ~CoinPresolveAction ()
| Virtual destructor. More...

## Static Public Member Functions
static const CoinPresolveAction * | presolve (CoinPresolveMatrix *prob, const CoinPresolveAction *next)
Static Public Member Functions inherited from CoinPresolveAction
static void | throwCoinError (const char *error, const char *ps_routine)
| Stub routine to throw exceptions. More...

## Private Member Functions
| dupcol_action ()
| dupcol_action (const dupcol_action &rhs)
dupcol_action & | operator= (const dupcol_action &rhs)
| dupcol_action (int nactions, const action *actions, const CoinPresolveAction *next)

## Private Attributes
const int | nactions_
const action *const | actions_

## Additional Inherited Members
Public Attributes inherited from CoinPresolveAction
const CoinPresolveAction * | next
| The next presolve transformation. More...

## Detailed Description

Detect and remove duplicate columns.

The general technique is to sum the coefficients a_(*,j) of each column. Columns with identical sums are duplicates. The obvious problem is that, e.g., [1 0 1 0] and [0 1 0 1] both add to 2. To minimize the chances of false positives, the coefficients of each row are multipled by a random number r_i, so that we sum r_i*a_ij.

Candidate columns are checked to confirm they are identical. Where the columns have the same objective coefficient, the two are combined. If the columns have different objective coefficients, complications ensue. In order to remove the duplicate, it must be possible to fix the variable at a bound.

Definition at line 32 of file CoinPresolveDupcol.hpp.

## Constructor & Destructor Documentation

dupcol_action::dupcol_action | ( |  | ) |
| private

dupcol_action::dupcol_action | ( | const dupcol_action & | rhs | ) |
| private

dupcol_action::dupcol_action | ( | int | nactions,
|  | const action * | actions,
|  | const CoinPresolveAction * | next
| ) |  |
| inline private

Definition at line 53 of file CoinPresolveDupcol.hpp.

virtual dupcol_action::~dupcol_action | ( |  | ) |
| virtual

## Member Function Documentation

dupcol_action& dupcol_action::operator= | ( | const dupcol_action & | rhs | ) |
| private

const char* dupcol_action::name | ( |  | ) | const
| virtual

A name for debug printing.

It is expected that the name is not stored in the transform itself.

Implements CoinPresolveAction.

static const CoinPresolveAction* dupcol_action::presolve | ( | CoinPresolveMatrix * | prob,
|  | const CoinPresolveAction * | next
| ) |  |
| static

void dupcol_action::postsolve | ( | CoinPostsolveMatrix * | prob | ) | const
| virtual

Apply the postsolve transformation for this particular presolve action.

Implements CoinPresolveAction.

## Member Data Documentation

const int dupcol_action::nactions_
| private

Definition at line 49 of file CoinPresolveDupcol.hpp.

const action* const dupcol_action::actions_
| private

Definition at line 51 of file CoinPresolveDupcol.hpp.

The documentation for this class was generated from the following file:

- /tmp/Osi-0.107.7/CoinUtils/src/CoinPresolveDupcol.hpp